#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme II/RTC Real Time Clock/RTC 5/RTC 5.c"
#line 29 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme II/RTC Real Time Clock/RTC 5/RTC 5.c"
sbit R_LED at LATD1_bit;
sbit R_LED_Direction at TRISD1_bit;
sbit G_LED at LATD2_bit;
sbit G_LED_Direction at TRISD2_bit;


void RTC_Init();
void RTC_writeUart();

void disablePIC32modules();
void enablePIC32();
void shutDownPIC32();



void RTCC_Interrupt() iv IVT_RTCC ilevel 7 ics ICS_AUTO {

 enablePIC32();
 UART2_Init(9600);

 UART2_Write_text("\x0DAwake and Reseting!!!\x0D");
 RTCCIF_bit = 0;
 Reset();

}

void enablePIC32(){

 SYSKEY = 0x0;
 SYSKEY = 0xAA996655;
 SYSKEY = 0x556699AA;

 CLKLOCK_bit = 0;
 SOSCEN_bit = 1;
 NOSC2_bit = 0;
 NOSC1_bit = 1;
 NOSC0_bit = 0;
 OSWEN_bit = 1;

 SLPEN_bit = 0;
 SYSKEY = 0x0;
}

void shutDownPIC32(){

 SYSKEY = 0x0;
 SYSKEY = 0xAA996655;
 SYSKEY = 0x556699AA;

 CLKLOCK_bit = 0;
 SOSCEN_bit = 1;
 NOSC2_bit = 1;
 NOSC1_bit = 0;
 NOSC0_bit = 0;
 OSWEN_bit = 1;

 SLPEN_bit = 1;
 SYSKEY = 0x0;
 asm {wait};
}





void disablePIC32modules(){


 C1CONbits.ON = 0;
 C2CONbits.ON = 0;
 CNCONbits.ON = 0;

 ETHCON1bits.ON = 0;
#line 111 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/Programme/Eigene Programme II/RTC Real Time Clock/RTC 5/RTC 5.c"
 WDTCONbits.ON = 0;


 TRISA = 0x0000;
 TRISB = 0x0000;
 TRISC = 0x0000;
 TRISD = 0x0000;
 TRISE = 0x0000;
 TRISG = 0x0000;

 PORTA = 0x0000;
 PORTB = 0x0000;
 PORTC = 0x0000;
 PORTD = 0x0000;
 PORTE = 0x0000;
 PORTF = 0x0000;
 PORTG = 0x0000;


 PMCONbits.ON = 0;


 T1CONbits.ON = 0;
 T2CONbits.ON = 0;
 T3CONbits.ON = 0;
 T4CONbits.ON = 0;
 T5CONbits.ON = 0;


 IC1CONbits.ON = 0;
 IC2CONbits.ON = 0;
 IC3CONbits.ON = 0;
 IC4CONbits.ON = 0;
 IC5CONbits.ON = 0;


 OC1CONbits.ON = 0;
 OC2CONbits.ON = 0;
 OC3CONbits.ON = 0;
 OC4CONbits.ON = 0;
 OC5CONbits.ON = 0;


 AD1CON1bits.ON = 0;


 CM1CONbits.ON = 0;
 CM2CONbits.ON = 0;


 CVRCONbits.ON = 0;


 U1MODEbits.ON = 0;
 U2MODEbits.ON = 0;
 U3MODEbits.ON = 0;
 U4MODEbits.ON = 0;
 U5MODEbits.ON = 0;
 U6MODEbits.ON = 0;


 SPI1CONbits.ON = 0;
 SPI2CONbits.ON = 0;
 SPI3CONbits.ON = 0;
 SPI4CONbits.ON = 0;


 I2C1CONbits.ON = 0;
 I2C2CONbits.ON = 0;
 I2C3CONbits.ON = 0;
 I2C4CONbits.ON = 0;
 I2C5CONbits.ON = 0;


 U1PWRCbits.USUSPEND = 1;
 U1PWRCbits.USBPWR = 0;
 U1CONbits.USBEN = 0;





 DMACONbits.ON = 0;


 DDPCONbits.JTAGEN = 0;
 DDPCONbits.TDOEN = 0;
 DDPCONbits.TROEN = 0;

}

void main() {
 int cnt = 0;

 AD1PCFG = 0xFFFF;
 JTAGEN_BIT = 0;

 TRISA = 0x0000;
 TRISB = 0x0000;
 TRISC = 0x0000;
 TRISD = 0x0000;
 TRISE = 0x0000;
 TRISG = 0x0000;

 PORTA = 0x0000;
 PORTB = 0x0000;
 PORTC = 0x0000;
 PORTD = 0x0000;
 PORTE = 0x0000;
 PORTF = 0x0000;
 PORTG = 0x0000;

 UART2_Init(9600);
 delay_ms(100);
 UART2_Write_text("\x0D\x0DuController started\xd");

 RTC_Init();

 EnableInterrupts();
 RTCCIE_bit = 1;

 cnt = 0;
 R_LED = 0;
 G_LED = 1;
 while(1){
 delay_ms(200);
 UART2_Write_text(".");
 LATDbits.LATD1 = ~PORTDbits.RD1;
 LATDbits.LATD2 = ~PORTDbits.RD2;
 cnt++;
 if(cnt == 10){
 cnt = 0;
 R_LED = 0;
 G_LED = 0;
 UART2_Write_text("\x0DGood Night!!!\xd");
 disablePIC32modules();
 shutDownPIC32();
 }
 }
}
