_RTCC_Interrupt:
;RTC 5.c,44 :: 		void RTCC_Interrupt() iv IVT_RTCC ilevel 7 ics ICS_AUTO {
RDPGPR	SP, SP
ADDIU	SP, SP, -16
SW	R30, 12(SP)
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;RTC 5.c,46 :: 		enablePIC32();
JAL	_enablePIC32+0
NOP	
;RTC 5.c,47 :: 		UART2_Init(9600);   // UART was deaactivated so it has to be initiated again
ORI	R25, R0, 9600
JAL	_UART2_Init+0
NOP	
;RTC 5.c,49 :: 		UART2_Write_text("\x0DAwake and Reseting!!!\x0D");
LUI	R25, #hi_addr(?lstr1_RTC_325+0)
ORI	R25, R25, #lo_addr(?lstr1_RTC_325+0)
JAL	_UART2_Write_Text+0
NOP	
;RTC 5.c,50 :: 		RTCCIF_bit = 0;
LUI	R2, BitMask(RTCCIF_bit+0)
ORI	R2, R2, BitMask(RTCCIF_bit+0)
_SX	8, Offset(RTCCIF_bit+4), 4
;RTC 5.c,51 :: 		Reset();
JAL	_Reset+0
NOP	
;RTC 5.c,53 :: 		}
L_end_RTCC_Interrupt:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
LW	R30, 12(SP)
ADDIU	SP, SP, 16
WRPGPR	SP, SP
ERET	
; end of _RTCC_Interrupt
_enablePIC32:
;RTC 5.c,55 :: 		void enablePIC32(){
;RTC 5.c,57 :: 		SYSKEY = 0x0;
SW	R0, Offset(SYSKEY+0)(GP)
;RTC 5.c,58 :: 		SYSKEY = 0xAA996655;
LUI	R2, 43673
ORI	R2, R2, 26197
SW	R2, Offset(SYSKEY+0)(GP)
;RTC 5.c,59 :: 		SYSKEY = 0x556699AA;
LUI	R2, 21862
ORI	R2, R2, 39338
SW	R2, Offset(SYSKEY+0)(GP)
;RTC 5.c,61 :: 		CLKLOCK_bit = 0;      // enable COSC
LUI	R2, BitMask(CLKLOCK_bit+0)
ORI	R2, R2, BitMask(CLKLOCK_bit+0)
_SX	8, Offset(CLKLOCK_bit+4), 4
;RTC 5.c,62 :: 		SOSCEN_bit = 1;
LUI	R2, BitMask(SOSCEN_bit+0)
ORI	R2, R2, BitMask(SOSCEN_bit+0)
_SX	8, Offset(SOSCEN_bit+8), 4
;RTC 5.c,63 :: 		NOSC2_bit = 0;
LUI	R2, BitMask(NOSC2_bit+0)
ORI	R2, R2, BitMask(NOSC2_bit+0)
_SX	8, Offset(NOSC2_bit+4), 4
;RTC 5.c,64 :: 		NOSC1_bit = 1;
LUI	R2, BitMask(NOSC1_bit+0)
ORI	R2, R2, BitMask(NOSC1_bit+0)
_SX	8, Offset(NOSC1_bit+8), 4
;RTC 5.c,65 :: 		NOSC0_bit = 0;
LUI	R2, BitMask(NOSC0_bit+0)
ORI	R2, R2, BitMask(NOSC0_bit+0)
_SX	8, Offset(NOSC0_bit+4), 4
;RTC 5.c,66 :: 		OSWEN_bit = 1;
LUI	R2, BitMask(OSWEN_bit+0)
ORI	R2, R2, BitMask(OSWEN_bit+0)
_SX	8, Offset(OSWEN_bit+8), 4
;RTC 5.c,68 :: 		SLPEN_bit = 0;
LUI	R2, BitMask(SLPEN_bit+0)
ORI	R2, R2, BitMask(SLPEN_bit+0)
_SX	8, Offset(SLPEN_bit+4), 4
;RTC 5.c,69 :: 		SYSKEY = 0x0;
SW	R0, Offset(SYSKEY+0)(GP)
;RTC 5.c,70 :: 		}
L_end_enablePIC32:
JR	RA
NOP	
; end of _enablePIC32
_shutDownPIC32:
;RTC 5.c,72 :: 		void shutDownPIC32(){
;RTC 5.c,74 :: 		SYSKEY = 0x0;
SW	R0, Offset(SYSKEY+0)(GP)
;RTC 5.c,75 :: 		SYSKEY = 0xAA996655;
LUI	R2, 43673
ORI	R2, R2, 26197
SW	R2, Offset(SYSKEY+0)(GP)
;RTC 5.c,76 :: 		SYSKEY = 0x556699AA;
LUI	R2, 21862
ORI	R2, R2, 39338
SW	R2, Offset(SYSKEY+0)(GP)
;RTC 5.c,78 :: 		CLKLOCK_bit = 0;      // enable  SOSC, disable COSC
LUI	R2, BitMask(CLKLOCK_bit+0)
ORI	R2, R2, BitMask(CLKLOCK_bit+0)
_SX	8, Offset(CLKLOCK_bit+4), 4
;RTC 5.c,79 :: 		SOSCEN_bit = 1;
LUI	R2, BitMask(SOSCEN_bit+0)
ORI	R2, R2, BitMask(SOSCEN_bit+0)
_SX	8, Offset(SOSCEN_bit+8), 4
;RTC 5.c,80 :: 		NOSC2_bit = 1;
LUI	R2, BitMask(NOSC2_bit+0)
ORI	R2, R2, BitMask(NOSC2_bit+0)
_SX	8, Offset(NOSC2_bit+8), 4
;RTC 5.c,81 :: 		NOSC1_bit = 0;
LUI	R2, BitMask(NOSC1_bit+0)
ORI	R2, R2, BitMask(NOSC1_bit+0)
_SX	8, Offset(NOSC1_bit+4), 4
;RTC 5.c,82 :: 		NOSC0_bit = 0;
LUI	R2, BitMask(NOSC0_bit+0)
ORI	R2, R2, BitMask(NOSC0_bit+0)
_SX	8, Offset(NOSC0_bit+4), 4
;RTC 5.c,83 :: 		OSWEN_bit = 1;
LUI	R2, BitMask(OSWEN_bit+0)
ORI	R2, R2, BitMask(OSWEN_bit+0)
_SX	8, Offset(OSWEN_bit+8), 4
;RTC 5.c,85 :: 		SLPEN_bit = 1;
LUI	R2, BitMask(SLPEN_bit+0)
ORI	R2, R2, BitMask(SLPEN_bit+0)
_SX	8, Offset(SLPEN_bit+8), 4
;RTC 5.c,86 :: 		SYSKEY = 0x0;
SW	R0, Offset(SYSKEY+0)(GP)
;RTC 5.c,87 :: 		asm {wait};            // wait for interrupts
WAIT	
;RTC 5.c,88 :: 		}
L_end_shutDownPIC32:
JR	RA
NOP	
; end of _shutDownPIC32
_disablePIC32modules:
;RTC 5.c,94 :: 		void disablePIC32modules(){
;RTC 5.c,97 :: 		C1CONbits.ON = 0; // CAN
ORI	R3, R0, 32768
SW	R3, Offset(C1CONbits+4)(GP)
;RTC 5.c,98 :: 		C2CONbits.ON = 0;
SW	R3, Offset(C2CONbits+4)(GP)
;RTC 5.c,99 :: 		CNCONbits.ON = 0; // CHANGE NOTICE AND PULL-UP REGISTER MAP
SW	R3, Offset(CNCONbits+4)(GP)
;RTC 5.c,101 :: 		ETHCON1bits.ON = 0;
SW	R3, Offset(ETHCON1bits+4)(GP)
;RTC 5.c,111 :: 		WDTCONbits.ON = 0;
SW	R3, Offset(WDTCONbits+4)(GP)
;RTC 5.c,114 :: 		TRISA = 0x0000;    // as OUTPUT
SW	R0, Offset(TRISA+0)(GP)
;RTC 5.c,115 :: 		TRISB = 0x0000;
SW	R0, Offset(TRISB+0)(GP)
;RTC 5.c,116 :: 		TRISC = 0x0000;
SW	R0, Offset(TRISC+0)(GP)
;RTC 5.c,117 :: 		TRISD = 0x0000;
SW	R0, Offset(TRISD+0)(GP)
;RTC 5.c,118 :: 		TRISE = 0x0000;
SW	R0, Offset(TRISE+0)(GP)
;RTC 5.c,119 :: 		TRISG = 0x0000;
SW	R0, Offset(TRISG+0)(GP)
;RTC 5.c,121 :: 		PORTA = 0x0000;    // as OUTPUT LOW
SW	R0, Offset(PORTA+0)(GP)
;RTC 5.c,122 :: 		PORTB = 0x0000;
SW	R0, Offset(PORTB+0)(GP)
;RTC 5.c,123 :: 		PORTC = 0x0000;
SW	R0, Offset(PORTC+0)(GP)
;RTC 5.c,124 :: 		PORTD = 0x0000;
SW	R0, Offset(PORTD+0)(GP)
;RTC 5.c,125 :: 		PORTE = 0x0000;
SW	R0, Offset(PORTE+0)(GP)
;RTC 5.c,126 :: 		PORTF = 0x0000;
SW	R0, Offset(PORTF+0)(GP)
;RTC 5.c,127 :: 		PORTG = 0x0000;
SW	R0, Offset(PORTG+0)(GP)
;RTC 5.c,130 :: 		PMCONbits.ON  = 0;
SW	R3, Offset(PMCONbits+4)(GP)
;RTC 5.c,133 :: 		T1CONbits.ON = 0;
SW	R3, Offset(T1CONbits+4)(GP)
;RTC 5.c,134 :: 		T2CONbits.ON = 0;
SW	R3, Offset(T2CONbits+4)(GP)
;RTC 5.c,135 :: 		T3CONbits.ON = 0;
SW	R3, Offset(T3CONbits+4)(GP)
;RTC 5.c,136 :: 		T4CONbits.ON = 0;
SW	R3, Offset(T4CONbits+4)(GP)
;RTC 5.c,137 :: 		T5CONbits.ON = 0;
SW	R3, Offset(T5CONbits+4)(GP)
;RTC 5.c,140 :: 		IC1CONbits.ON = 0;
SW	R3, Offset(IC1CONbits+4)(GP)
;RTC 5.c,141 :: 		IC2CONbits.ON = 0;
SW	R3, Offset(IC2CONbits+4)(GP)
;RTC 5.c,142 :: 		IC3CONbits.ON = 0;
SW	R3, Offset(IC3CONbits+4)(GP)
;RTC 5.c,143 :: 		IC4CONbits.ON = 0;
SW	R3, Offset(IC4CONbits+4)(GP)
;RTC 5.c,144 :: 		IC5CONbits.ON = 0;
SW	R3, Offset(IC5CONbits+4)(GP)
;RTC 5.c,147 :: 		OC1CONbits.ON = 0;
SW	R3, Offset(OC1CONbits+4)(GP)
;RTC 5.c,148 :: 		OC2CONbits.ON = 0;
SW	R3, Offset(OC2CONbits+4)(GP)
;RTC 5.c,149 :: 		OC3CONbits.ON = 0;
SW	R3, Offset(OC3CONbits+4)(GP)
;RTC 5.c,150 :: 		OC4CONbits.ON = 0;
SW	R3, Offset(OC4CONbits+4)(GP)
;RTC 5.c,151 :: 		OC5CONbits.ON = 0;
SW	R3, Offset(OC5CONbits+4)(GP)
;RTC 5.c,154 :: 		AD1CON1bits.ON = 0;
SW	R3, Offset(AD1CON1bits+4)(GP)
;RTC 5.c,157 :: 		CM1CONbits.ON = 0;   // COMPARATOR REGISTER MAP
SW	R3, Offset(CM1CONbits+4)(GP)
;RTC 5.c,158 :: 		CM2CONbits.ON = 0;
SW	R3, Offset(CM2CONbits+4)(GP)
;RTC 5.c,161 :: 		CVRCONbits.ON = 0;   // COMPARATOR VOLTAGE REFERENCE REGISTER MAP
SW	R3, Offset(CVRCONbits+4)(GP)
;RTC 5.c,164 :: 		U1MODEbits.ON = 0;
SW	R3, Offset(U1MODEbits+4)(GP)
;RTC 5.c,165 :: 		U2MODEbits.ON = 0;
SW	R3, Offset(U2MODEbits+4)(GP)
;RTC 5.c,166 :: 		U3MODEbits.ON = 0;
SW	R3, Offset(U3MODEbits+4)(GP)
;RTC 5.c,167 :: 		U4MODEbits.ON = 0;
SW	R3, Offset(U4MODEbits+4)(GP)
;RTC 5.c,168 :: 		U5MODEbits.ON = 0;
SW	R3, Offset(U5MODEbits+4)(GP)
;RTC 5.c,169 :: 		U6MODEbits.ON = 0;
SW	R3, Offset(U6MODEbits+4)(GP)
;RTC 5.c,172 :: 		SPI1CONbits.ON = 0;
SW	R3, Offset(SPI1CONbits+4)(GP)
;RTC 5.c,173 :: 		SPI2CONbits.ON = 0;
SW	R3, Offset(SPI2CONbits+4)(GP)
;RTC 5.c,174 :: 		SPI3CONbits.ON = 0;
SW	R3, Offset(SPI3CONbits+4)(GP)
;RTC 5.c,175 :: 		SPI4CONbits.ON = 0;
SW	R3, Offset(SPI4CONbits+4)(GP)
;RTC 5.c,178 :: 		I2C1CONbits.ON = 0;
SW	R3, Offset(I2C1CONbits+4)(GP)
;RTC 5.c,179 :: 		I2C2CONbits.ON = 0;
SW	R3, Offset(I2C2CONbits+4)(GP)
;RTC 5.c,180 :: 		I2C3CONbits.ON = 0;
SW	R3, Offset(I2C3CONbits+4)(GP)
;RTC 5.c,181 :: 		I2C4CONbits.ON = 0;
SW	R3, Offset(I2C4CONbits+4)(GP)
;RTC 5.c,182 :: 		I2C5CONbits.ON = 0;
SW	R3, Offset(I2C5CONbits+4)(GP)
;RTC 5.c,185 :: 		U1PWRCbits.USUSPEND = 1;      // put USB in suspend mode  PAGE 892
ORI	R2, R0, 2
SWR	R2, Offset(U1PWRCbits+8)(GP)
SWR	R2, Offset(U1PWRCbits+8)(GP)
;RTC 5.c,186 :: 		U1PWRCbits.USBPWR   = 0;      // disable USB power
ORI	R2, R0, 1
SWR	R2, Offset(U1PWRCbits+4)(GP)
SWR	R2, Offset(U1PWRCbits+4)(GP)
;RTC 5.c,187 :: 		U1CONbits.USBEN     = 0;      //disable entire usb module   P 902
SWR	R2, Offset(U1CONbits+4)(GP)
SWR	R2, Offset(U1CONbits+4)(GP)
;RTC 5.c,193 :: 		DMACONbits.ON = 0;
SW	R3, Offset(DMACONbits+4)(GP)
;RTC 5.c,196 :: 		DDPCONbits.JTAGEN = 0;        // disable JTAG port
LBU	R2, Offset(DDPCONbits+0)(GP)
INS	R2, R0, 3, 1
SB	R2, Offset(DDPCONbits+0)(GP)
;RTC 5.c,197 :: 		DDPCONbits.TDOEN = 0;
LBU	R2, Offset(DDPCONbits+0)(GP)
INS	R2, R0, 0, 1
SB	R2, Offset(DDPCONbits+0)(GP)
;RTC 5.c,198 :: 		DDPCONbits.TROEN = 0;
LBU	R2, Offset(DDPCONbits+0)(GP)
INS	R2, R0, 2, 1
SB	R2, Offset(DDPCONbits+0)(GP)
;RTC 5.c,200 :: 		}
L_end_disablePIC32modules:
JR	RA
NOP	
; end of _disablePIC32modules
_main:
;RTC 5.c,202 :: 		void main() {
;RTC 5.c,203 :: 		int cnt = 0;
;RTC 5.c,205 :: 		AD1PCFG = 0xFFFF;    // initialize pins RB0 Strom,RB1 Spannung & RB8 Temperatur als analog; rest ist Digital
ORI	R2, R0, 65535
SW	R2, Offset(AD1PCFG+0)(GP)
;RTC 5.c,206 :: 		JTAGEN_BIT = 0;
_LX	, 4
INS	R2, R0, BitPos(JTAGEN_bit+0), 1
_SX	8, Offset(JTAGEN_bit+0), 4
;RTC 5.c,208 :: 		TRISA = 0x0000;    // as OUTPUT
SW	R0, Offset(TRISA+0)(GP)
;RTC 5.c,209 :: 		TRISB = 0x0000;
SW	R0, Offset(TRISB+0)(GP)
;RTC 5.c,210 :: 		TRISC = 0x0000;
SW	R0, Offset(TRISC+0)(GP)
;RTC 5.c,211 :: 		TRISD = 0x0000;
SW	R0, Offset(TRISD+0)(GP)
;RTC 5.c,212 :: 		TRISE = 0x0000;
SW	R0, Offset(TRISE+0)(GP)
;RTC 5.c,213 :: 		TRISG = 0x0000;
SW	R0, Offset(TRISG+0)(GP)
;RTC 5.c,215 :: 		PORTA = 0x0000;    // as OUTPUT LOW
SW	R0, Offset(PORTA+0)(GP)
;RTC 5.c,216 :: 		PORTB = 0x0000;
SW	R0, Offset(PORTB+0)(GP)
;RTC 5.c,217 :: 		PORTC = 0x0000;
SW	R0, Offset(PORTC+0)(GP)
;RTC 5.c,218 :: 		PORTD = 0x0000;
SW	R0, Offset(PORTD+0)(GP)
;RTC 5.c,219 :: 		PORTE = 0x0000;
SW	R0, Offset(PORTE+0)(GP)
;RTC 5.c,220 :: 		PORTF = 0x0000;
SW	R0, Offset(PORTF+0)(GP)
;RTC 5.c,221 :: 		PORTG = 0x0000;
SW	R0, Offset(PORTG+0)(GP)
;RTC 5.c,223 :: 		UART2_Init(9600);
ORI	R25, R0, 9600
JAL	_UART2_Init+0
NOP	
;RTC 5.c,224 :: 		delay_ms(100);
LUI	R24, 4
ORI	R24, R24, 4522
L_main0:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main0
NOP	
;RTC 5.c,225 :: 		UART2_Write_text("\x0D\x0DuController started\xd");
LUI	R25, #hi_addr(?lstr2_RTC_325+0)
ORI	R25, R25, #lo_addr(?lstr2_RTC_325+0)
JAL	_UART2_Write_Text+0
NOP	
;RTC 5.c,227 :: 		RTC_Init();
JAL	_RTC_Init+0
NOP	
;RTC 5.c,229 :: 		EnableInterrupts();
EI	R30
;RTC 5.c,230 :: 		RTCCIE_bit = 1;
LUI	R2, BitMask(RTCCIE_bit+0)
ORI	R2, R2, BitMask(RTCCIE_bit+0)
_SX	8, Offset(RTCCIE_bit+8), 4
;RTC 5.c,232 :: 		cnt = 0;
; cnt start address is: 20 (R5)
MOVZ	R5, R0, R0
;RTC 5.c,233 :: 		R_LED = 0;
LUI	R2, BitMask(LATD1_bit+0)
ORI	R2, R2, BitMask(LATD1_bit+0)
_SX	8, Offset(LATD1_bit+4), 4
;RTC 5.c,234 :: 		G_LED = 1;
LUI	R2, BitMask(LATD2_bit+0)
ORI	R2, R2, BitMask(LATD2_bit+0)
_SX	8, Offset(LATD2_bit+8), 4
; cnt end address is: 20 (R5)
;RTC 5.c,235 :: 		while(1){
L_main2:
;RTC 5.c,236 :: 		delay_ms(200);
; cnt start address is: 20 (R5)
LUI	R24, 8
ORI	R24, R24, 9044
L_main4:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main4
NOP	
NOP	
NOP	
;RTC 5.c,237 :: 		UART2_Write_text(".");
LUI	R25, #hi_addr(?lstr3_RTC_325+0)
ORI	R25, R25, #lo_addr(?lstr3_RTC_325+0)
JAL	_UART2_Write_Text+0
NOP	
;RTC 5.c,238 :: 		LATDbits.LATD1 = ~PORTDbits.RD1;
LBU	R2, Offset(PORTDbits+0)(GP)
EXT	R2, R2, 1, 1
XORI	R3, R2, 1
LBU	R2, Offset(LATDbits+0)(GP)
INS	R2, R3, 1, 1
SB	R2, Offset(LATDbits+0)(GP)
;RTC 5.c,239 :: 		LATDbits.LATD2 = ~PORTDbits.RD2;
LBU	R2, Offset(PORTDbits+0)(GP)
EXT	R2, R2, 2, 1
XORI	R3, R2, 1
LBU	R2, Offset(LATDbits+0)(GP)
INS	R2, R3, 2, 1
SB	R2, Offset(LATDbits+0)(GP)
;RTC 5.c,240 :: 		cnt++;
ADDIU	R2, R5, 1
; cnt end address is: 20 (R5)
; cnt start address is: 16 (R4)
SEH	R4, R2
;RTC 5.c,241 :: 		if(cnt == 10){
SEH	R3, R2
ORI	R2, R0, 10
BEQ	R3, R2, L__main13
NOP	
J	L__main7
NOP	
L__main13:
; cnt end address is: 16 (R4)
;RTC 5.c,242 :: 		cnt = 0;
; cnt start address is: 20 (R5)
MOVZ	R5, R0, R0
;RTC 5.c,243 :: 		R_LED = 0;
LUI	R2, BitMask(LATD1_bit+0)
ORI	R2, R2, BitMask(LATD1_bit+0)
_SX	8, Offset(LATD1_bit+4), 4
;RTC 5.c,244 :: 		G_LED = 0;
LUI	R2, BitMask(LATD2_bit+0)
ORI	R2, R2, BitMask(LATD2_bit+0)
_SX	8, Offset(LATD2_bit+4), 4
;RTC 5.c,245 :: 		UART2_Write_text("\x0DGood Night!!!\xd");
LUI	R25, #hi_addr(?lstr4_RTC_325+0)
ORI	R25, R25, #lo_addr(?lstr4_RTC_325+0)
JAL	_UART2_Write_Text+0
NOP	
;RTC 5.c,246 :: 		disablePIC32modules();
JAL	_disablePIC32modules+0
NOP	
;RTC 5.c,247 :: 		shutDownPIC32();
JAL	_shutDownPIC32+0
NOP	
; cnt end address is: 20 (R5)
;RTC 5.c,248 :: 		}
J	L_main6
NOP	
L__main7:
;RTC 5.c,241 :: 		if(cnt == 10){
SEH	R5, R4
;RTC 5.c,248 :: 		}
L_main6:
;RTC 5.c,249 :: 		}
; cnt start address is: 20 (R5)
; cnt end address is: 20 (R5)
J	L_main2
NOP	
;RTC 5.c,250 :: 		}
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
