_Set_RTC:
;RTCC_driver.c,14 :: 		void Set_RTC(TTime *RTCC_Time, TTime *ALARM_Time){
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;RTCC_driver.c,15 :: 		unsigned long temp_time = 0, temp_date = 0, temp_alarm_time = 0, temp_alarm_date = 0;
SW	R25, 4(SP)
;RTCC_driver.c,17 :: 		RTCCIE_bit = 0;
LUI	R2, BitMask(RTCCIE_bit+0)
ORI	R2, R2, BitMask(RTCCIE_bit+0)
_SX	8, Offset(RTCCIE_bit+4), 4
;RTCC_driver.c,19 :: 		temp_time = (unsigned long)Dec2Bcd(RTCC_Time->hours) << 24;
ADDIU	R2, R25, 2
SW	R25, 8(SP)
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
LW	R25, 8(SP)
ANDI	R2, R2, 255
SLL	R2, R2, 24
; temp_time start address is: 16 (R4)
MOVZ	R4, R2, R0
;RTCC_driver.c,20 :: 		temp_time += (unsigned long)Dec2BCD(RTCC_Time->minutes) << 16;
ADDIU	R2, R25, 1
SW	R25, 8(SP)
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
LW	R25, 8(SP)
ANDI	R2, R2, 255
SLL	R2, R2, 16
ADDU	R2, R4, R2
MOVZ	R4, R2, R0
;RTCC_driver.c,21 :: 		temp_time += (unsigned long)Dec2BCD(RTCC_Time->seconds) << 8;
SW	R25, 8(SP)
LB	R25, 0(R25)
JAL	_Dec2Bcd+0
NOP	
LW	R25, 8(SP)
ANDI	R2, R2, 255
SLL	R2, R2, 8
ADDU	R2, R4, R2
MOVZ	R4, R2, R0
;RTCC_driver.c,23 :: 		temp_date = (unsigned long)Dec2Bcd(RTCC_Time->year) << 24;
ADDIU	R2, R25, 6
SW	R25, 8(SP)
LH	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
LW	R25, 8(SP)
ANDI	R2, R2, 255
SLL	R2, R2, 24
; temp_date start address is: 20 (R5)
MOVZ	R5, R2, R0
;RTCC_driver.c,24 :: 		temp_date += (unsigned long)Dec2BCD(RTCC_Time->month) << 16;
ADDIU	R2, R25, 4
SW	R25, 8(SP)
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
LW	R25, 8(SP)
ANDI	R2, R2, 255
SLL	R2, R2, 16
ADDU	R2, R5, R2
MOVZ	R5, R2, R0
;RTCC_driver.c,25 :: 		temp_date += (unsigned long)Dec2BCD(RTCC_Time->day) << 8;
ADDIU	R2, R25, 3
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 8
ADDU	R2, R5, R2
MOVZ	R5, R2, R0
;RTCC_driver.c,27 :: 		temp_alarm_time = (unsigned long)Dec2Bcd(ALARM_Time->hours) << 24;
ADDIU	R2, R26, 2
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 24
; temp_alarm_time start address is: 24 (R6)
MOVZ	R6, R2, R0
;RTCC_driver.c,28 :: 		temp_alarm_time += (unsigned long)Dec2BCD(ALARM_Time->minutes) << 16;
ADDIU	R2, R26, 1
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 16
ADDU	R2, R6, R2
MOVZ	R6, R2, R0
;RTCC_driver.c,29 :: 		temp_alarm_time += (unsigned long)Dec2BCD(ALARM_Time->seconds) << 8;
LB	R25, 0(R26)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 8
ADDU	R2, R6, R2
MOVZ	R6, R2, R0
;RTCC_driver.c,31 :: 		temp_alarm_date = (unsigned long)Dec2Bcd(ALARM_Time->year) << 24;
ADDIU	R2, R26, 6
LH	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 24
; temp_alarm_date start address is: 28 (R7)
MOVZ	R7, R2, R0
;RTCC_driver.c,32 :: 		temp_alarm_date += (unsigned long)Dec2BCD(ALARM_Time->month) << 16;
ADDIU	R2, R26, 4
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 16
ADDU	R2, R7, R2
MOVZ	R7, R2, R0
;RTCC_driver.c,33 :: 		temp_alarm_date += (unsigned long)Dec2BCD(ALARM_Time->day) << 8;
ADDIU	R2, R26, 3
LB	R25, 0(R2)
JAL	_Dec2Bcd+0
NOP	
ANDI	R2, R2, 255
SLL	R2, R2, 8
ADDU	R2, R7, R2
; temp_alarm_date end address is: 28 (R7)
; temp_alarm_date start address is: 12 (R3)
MOVZ	R3, R2, R0
;RTCC_driver.c,37 :: 		SYSKEY = 0xAA996655;       // RTCC registers unlock procedure
LUI	R2, 43673
ORI	R2, R2, 26197
SW	R2, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,38 :: 		SYSKEY = 0x556699AA;
LUI	R2, 21862
ORI	R2, R2, 39338
SW	R2, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,40 :: 		RTCWREN_bit = 1;           // RTC Value registers can be written to by the user
LUI	R2, BitMask(RTCWREN_bit+0)
ORI	R2, R2, BitMask(RTCWREN_bit+0)
_SX	8, Offset(RTCWREN_bit+8), 4
;RTCC_driver.c,42 :: 		ON__RTCCON_bit = 0;        // Turn off the RTCC module
LUI	R2, BitMask(ON__RTCCON_bit+0)
ORI	R2, R2, BitMask(ON__RTCCON_bit+0)
_SX	8, Offset(ON__RTCCON_bit+4), 4
; temp_time end address is: 16 (R4)
; temp_alarm_time end address is: 24 (R6)
; temp_alarm_date end address is: 12 (R3)
; temp_date end address is: 20 (R5)
SW	R6, 8(SP)
MOVZ	R6, R4, R0
LW	R4, 8(SP)
;RTCC_driver.c,44 :: 		while (RTCCLKON_bit)       // Wait for clock to be turned off
L_Set_RTC0:
; temp_alarm_date start address is: 12 (R3)
; temp_alarm_time start address is: 16 (R4)
; temp_date start address is: 20 (R5)
; temp_time start address is: 24 (R6)
_LX	, 4
EXT	R2, R2, BitPos(RTCCLKON_bit+0), 1
BNE	R2, R0, L__Set_RTC8
NOP	
J	L_Set_RTC1
NOP	
L__Set_RTC8:
;RTCC_driver.c,45 :: 		;
J	L_Set_RTC0
NOP	
L_Set_RTC1:
;RTCC_driver.c,47 :: 		RTCTIME = temp_time;
SW	R6, Offset(RTCTIME+0)(GP)
; temp_time end address is: 24 (R6)
;RTCC_driver.c,48 :: 		RTCDATE = temp_date;
SW	R5, Offset(RTCDATE+0)(GP)
; temp_alarm_date end address is: 12 (R3)
; temp_alarm_time end address is: 16 (R4)
; temp_date end address is: 20 (R5)
SW	R4, 8(SP)
MOVZ	R4, R3, R0
LW	R3, 8(SP)
;RTCC_driver.c,50 :: 		while (ALRMSYNC_bit)       // Wait for alarm clock to be turned off
L_Set_RTC2:
; temp_alarm_time start address is: 12 (R3)
; temp_alarm_date start address is: 16 (R4)
_LX	, 4
EXT	R2, R2, BitPos(ALRMSYNC_bit+0), 1
BNE	R2, R0, L__Set_RTC10
NOP	
J	L_Set_RTC3
NOP	
L__Set_RTC10:
;RTCC_driver.c,51 :: 		;
J	L_Set_RTC2
NOP	
L_Set_RTC3:
;RTCC_driver.c,53 :: 		RTCALRMCLR=0xCFFF; // clear ALRMEN, CHIME, AMASK and ARPT;
ORI	R2, R0, 53247
SW	R2, Offset(RTCALRMCLR+0)(GP)
;RTCC_driver.c,55 :: 		ALRMTIMECLR = 0xFFFFFFFF;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(ALRMTIMECLR+0)(GP)
;RTCC_driver.c,56 :: 		ALRMDATECLR = 0xFFFFFFFF;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(ALRMDATECLR+0)(GP)
;RTCC_driver.c,58 :: 		ALRMTIME = temp_alarm_time;
SW	R3, Offset(ALRMTIME+0)(GP)
; temp_alarm_time end address is: 12 (R3)
;RTCC_driver.c,59 :: 		ALRMDATE = temp_alarm_date;
SW	R4, Offset(ALRMDATE+0)(GP)
; temp_alarm_date end address is: 16 (R4)
;RTCC_driver.c,61 :: 		RTCALRMSET = 0x8600;
ORI	R2, R0, 34304
SW	R2, Offset(RTCALRMSET+0)(GP)
;RTCC_driver.c,63 :: 		RTSECSEL_bit = 0;         // Use RTC interrupt
LUI	R2, BitMask(RTSECSEL_bit+0)
ORI	R2, R2, BitMask(RTSECSEL_bit+0)
_SX	8, Offset(RTSECSEL_bit+4), 4
;RTCC_driver.c,65 :: 		ON__RTCCON_bit = 1;        // Turn on the RTCC module
LUI	R2, BitMask(ON__RTCCON_bit+0)
ORI	R2, R2, BitMask(ON__RTCCON_bit+0)
_SX	8, Offset(ON__RTCCON_bit+8), 4
;RTCC_driver.c,66 :: 		while (!RTCCLKON_bit)      // Wait for clock to be turned on
L_Set_RTC4:
_LX	, 4
EXT	R2, R2, BitPos(RTCCLKON_bit+0), 1
BEQ	R2, R0, L__Set_RTC11
NOP	
J	L_Set_RTC5
NOP	
L__Set_RTC11:
;RTCC_driver.c,67 :: 		;
J	L_Set_RTC4
NOP	
L_Set_RTC5:
;RTCC_driver.c,69 :: 		RTCCIF_bit = 0;
LUI	R2, BitMask(RTCCIF_bit+0)
ORI	R2, R2, BitMask(RTCCIF_bit+0)
_SX	8, Offset(RTCCIF_bit+4), 4
;RTCC_driver.c,70 :: 		RTCCIE_bit = 1;
LUI	R2, BitMask(RTCCIE_bit+0)
ORI	R2, R2, BitMask(RTCCIE_bit+0)
_SX	8, Offset(RTCCIE_bit+8), 4
;RTCC_driver.c,71 :: 		}
L_end_Set_RTC:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _Set_RTC
_RTC_Init:
;RTCC_driver.c,73 :: 		void RTC_Init(){
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;RTCC_driver.c,75 :: 		SYSKEY = 0x0;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R0, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,76 :: 		SYSKEY = 0xAA996655;
LUI	R2, 43673
ORI	R2, R2, 26197
SW	R2, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,77 :: 		SYSKEY = 0x556699AA;
LUI	R2, 21862
ORI	R2, R2, 39338
SW	R2, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,79 :: 		CLKLOCK_bit = 0;
LUI	R2, BitMask(CLKLOCK_bit+0)
ORI	R2, R2, BitMask(CLKLOCK_bit+0)
_SX	8, Offset(CLKLOCK_bit+4), 4
;RTCC_driver.c,80 :: 		SOSCEN_bit = 1;        // enable seconday oscillator
LUI	R2, BitMask(SOSCEN_bit+0)
ORI	R2, R2, BitMask(SOSCEN_bit+0)
_SX	8, Offset(SOSCEN_bit+8), 4
;RTCC_driver.c,81 :: 		OSWEN_bit = 1;
LUI	R2, BitMask(OSWEN_bit+0)
ORI	R2, R2, BitMask(OSWEN_bit+0)
_SX	8, Offset(OSWEN_bit+8), 4
;RTCC_driver.c,83 :: 		SLPEN_bit = 1;
LUI	R2, BitMask(SLPEN_bit+0)
ORI	R2, R2, BitMask(SLPEN_bit+0)
_SX	8, Offset(SLPEN_bit+8), 4
;RTCC_driver.c,84 :: 		SYSKEY = 0x0;          // Force lock
SW	R0, Offset(SYSKEY+0)(GP)
;RTCC_driver.c,86 :: 		RTCCIP0_bit = 1;       // Set RTCC interrupt
LUI	R2, BitMask(RTCCIP0_bit+0)
ORI	R2, R2, BitMask(RTCCIP0_bit+0)
_SX	8, Offset(RTCCIP0_bit+8), 4
;RTCC_driver.c,87 :: 		RTCCIP1_bit = 1;       // priority level
LUI	R2, BitMask(RTCCIP1_bit+0)
ORI	R2, R2, BitMask(RTCCIP1_bit+0)
_SX	8, Offset(RTCCIP1_bit+8), 4
;RTCC_driver.c,88 :: 		RTCCIP2_bit = 1;       // to 7
LUI	R2, BitMask(RTCCIP2_bit+0)
ORI	R2, R2, BitMask(RTCCIP2_bit+0)
_SX	8, Offset(RTCCIP2_bit+8), 4
;RTCC_driver.c,90 :: 		MyTime.seconds = 0;
SB	R0, Offset(_MyTime+0)(GP)
;RTCC_driver.c,91 :: 		MyTime.minutes = 0;
SB	R0, Offset(_MyTime+1)(GP)
;RTCC_driver.c,92 :: 		MyTime.hours = 11;
ORI	R2, R0, 11
SB	R2, Offset(_MyTime+2)(GP)
;RTCC_driver.c,93 :: 		MyTime.day = 1;
ORI	R2, R0, 1
SB	R2, Offset(_MyTime+3)(GP)
;RTCC_driver.c,94 :: 		MyTime.month = 11;
ORI	R2, R0, 11
SB	R2, Offset(_MyTime+4)(GP)
;RTCC_driver.c,95 :: 		MyTime.year = 11;
ORI	R2, R0, 11
SH	R2, Offset(_MyTime+6)(GP)
;RTCC_driver.c,98 :: 		AlarmTime.seconds = 10;
ORI	R2, R0, 10
SB	R2, Offset(_AlarmTime+0)(GP)
;RTCC_driver.c,99 :: 		AlarmTime.minutes = 0;
SB	R0, Offset(_AlarmTime+1)(GP)
;RTCC_driver.c,100 :: 		AlarmTime.hours = 11;
ORI	R2, R0, 11
SB	R2, Offset(_AlarmTime+2)(GP)
;RTCC_driver.c,101 :: 		AlarmTime.day = 1;
ORI	R2, R0, 1
SB	R2, Offset(_AlarmTime+3)(GP)
;RTCC_driver.c,102 :: 		AlarmTime.month = 11;
ORI	R2, R0, 11
SB	R2, Offset(_AlarmTime+4)(GP)
;RTCC_driver.c,103 :: 		AlarmTime.year = 11;
ORI	R2, R0, 11
SH	R2, Offset(_AlarmTime+6)(GP)
;RTCC_driver.c,105 :: 		Set_RTC(&MyTime, &AlarmTime);
LUI	R26, #hi_addr(_AlarmTime+0)
ORI	R26, R26, #lo_addr(_AlarmTime+0)
LUI	R25, #hi_addr(_MyTime+0)
ORI	R25, R25, #lo_addr(_MyTime+0)
JAL	_Set_RTC+0
NOP	
;RTCC_driver.c,106 :: 		}
L_end_RTC_Init:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _RTC_Init
